#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern GtkWidget *window;
extern GtkWidget *notebook;

extern GtkWidget *enable_effects_checkbutton;
extern GtkWidget *hardware_rendering_radiobutton;
extern GtkWidget *software_rendering_radiobutton;
extern GtkWidget *hardware_combobox;
extern GtkWidget *hardware_expander;
extern GtkWidget *wobbly_checkbutton;
extern GtkWidget *fade_checkbutton;
extern GtkWidget *cube_checkbutton;
extern GtkWidget *rotate_checkbutton;
extern GtkWidget *zoom_checkbutton;
extern GtkWidget *move_checkbutton;
extern GtkWidget *resize_checkbutton;
extern GtkWidget *placement_checkbutton;
extern GtkWidget *menu_checkbutton;
extern GtkWidget *switcher_checkbutton;
extern GtkWidget *scale_checkbutton;
extern GtkWidget *decoration_checkbutton;
extern GtkWidget *software_expander;
extern GtkWidget *software_combobox;
extern GtkWidget *dropshadow_checkbutton;
extern GtkWidget *avoid_checkbutton;
extern GtkWidget *fadeinout_checkbutton;
extern GtkWidget *fadewindow_checkbutton;
extern GtkWidget *blur_spinbutton;
extern GtkWidget *translucency_spinbutton;
extern GtkWidget *left_spinbutton;
extern GtkWidget *top_spinbutton;
extern GtkWidget *fadeinopacity_spinbutton;
extern GtkWidget *fadeoutopacity_spinbutton;
extern GtkWidget *time_spinbutton;
extern GtkWidget *about_button;
extern GtkWidget *cancel_button;
extern GtkWidget *ok_button;

void
on_enable_effects_checkbutton_toggled (GtkToggleButton * togglebutton,
				       gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (hardware_combobox), 0);
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 0);

  if (gtk_toggle_button_get_active
      (GTK_TOGGLE_BUTTON (enable_effects_checkbutton)))
    {
      gtk_widget_set_sensitive (hardware_rendering_radiobutton, TRUE);
      gtk_widget_set_sensitive (software_rendering_radiobutton, TRUE);
      if (gtk_toggle_button_get_active
	  (GTK_TOGGLE_BUTTON (hardware_rendering_radiobutton)))
	{
	  gtk_widget_show (hardware_expander);
	}
      else
	{
	  gtk_widget_show (software_expander);
	}
    }
  else
    {
      gtk_widget_set_sensitive (hardware_rendering_radiobutton, FALSE);
      gtk_widget_set_sensitive (software_rendering_radiobutton, FALSE);
      if (gtk_toggle_button_get_active
	  (GTK_TOGGLE_BUTTON (hardware_rendering_radiobutton)))
	{
	  gtk_widget_hide (hardware_expander);
	}
      else
	{
	  gtk_widget_hide (software_expander);
	}
    }

}


void
  on_hardware_rendering_radiobutton_toggled
  (GtkToggleButton * togglebutton, gpointer user_data)
{

  if (gtk_toggle_button_get_active
      (GTK_TOGGLE_BUTTON (hardware_rendering_radiobutton)))
    {
      gtk_widget_hide (software_expander);
      gtk_widget_show (hardware_expander);
    }

}

void
  on_software_rendering_radiobutton_toggled
  (GtkToggleButton * togglebutton, gpointer user_data)
{

  if (gtk_toggle_button_get_active
      (GTK_TOGGLE_BUTTON (software_rendering_radiobutton)))
    {
      gtk_widget_hide (hardware_expander);
      gtk_widget_show (software_expander);
    }

}

void
on_window_destroy (GtkObject * object, gpointer user_data)
{
  g_print ("exit");
  gtk_main_quit ();
}


void
on_hardware_combobox_changed (GtkComboBox * combobox, gpointer user_data)
{

}


void
on_software_combobox_changed (GtkComboBox * combobox, gpointer user_data)
{

  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) == 0)
    {
      gtk_toggle_button_set_active (dropshadow_checkbutton, TRUE);
      gtk_toggle_button_set_active (dropshadow_checkbutton, TRUE);
      gtk_toggle_button_set_active (avoid_checkbutton, FALSE);
      gtk_toggle_button_set_active (fadeinout_checkbutton, TRUE);
      gtk_toggle_button_set_active (fadewindow_checkbutton, TRUE);
      gtk_spin_button_set_value (blur_spinbutton, 12);
      gtk_spin_button_set_value (translucency_spinbutton, 0.75);
      gtk_spin_button_set_value (left_spinbutton, -15);
      gtk_spin_button_set_value (top_spinbutton, -15);
      gtk_spin_button_set_value (fadeinopacity_spinbutton, 0.028);
      gtk_spin_button_set_value (fadeoutopacity_spinbutton, 0.030);
      gtk_spin_button_set_value (time_spinbutton, 10);
      gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 0);
    }

  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) == 1)
    {
      gtk_toggle_button_set_active (dropshadow_checkbutton, TRUE);
      gtk_toggle_button_set_active (dropshadow_checkbutton, TRUE);
      gtk_toggle_button_set_active (avoid_checkbutton, TRUE);
      gtk_toggle_button_set_active (fadeinout_checkbutton, TRUE);
      gtk_toggle_button_set_active (fadewindow_checkbutton, TRUE);
      gtk_spin_button_set_value (blur_spinbutton, 7);
      gtk_spin_button_set_value (translucency_spinbutton, 0.65);
      gtk_spin_button_set_value (left_spinbutton, -10);
      gtk_spin_button_set_value (top_spinbutton, -8);
      gtk_spin_button_set_value (fadeinopacity_spinbutton, 0.028);
      gtk_spin_button_set_value (fadeoutopacity_spinbutton, 0.030);
      gtk_spin_button_set_value (time_spinbutton, 7);
      gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 1);
    }

  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) == 2)
    {

    }

  return 0;
}


void
on_about_button_clicked (GtkButton * button, gpointer user_data)
{
  notebook = lookup_widget (GTK_WIDGET (window), "notebook");
  gtk_notebook_set_current_page (GTK_NOTEBOOK (notebook), 1);
}


void
on_cancel_button_clicked (GtkButton * button, gpointer user_data)
{
  g_print ("exit");
  gtk_main_quit ();
}


void
on_ok_button_clicked (GtkButton * button, gpointer user_data)
{
  if (gtk_toggle_button_get_active
      (GTK_TOGGLE_BUTTON (enable_effects_checkbutton)))
    {
      g_print ("enable effects\n");
      if (gtk_toggle_button_get_active
	  (GTK_TOGGLE_BUTTON (hardware_rendering_radiobutton)))
	{
	  g_print ("hardware rendering\n");

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (hardware_combobox)) ==
	      0)
	    {
	      g_print ("ati hardware\n");
	    }

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (hardware_combobox)) ==
	      1)
	    {
	      g_print ("nvidia hardware\n");
	    }

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (hardware_combobox)) ==
	      2)
	    {
	      g_print ("other hardware\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (wobbly_checkbutton)))
	    {
	      g_print ("wobbly\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (fade_checkbutton)))
	    {
	      g_print ("fade\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (cube_checkbutton)))
	    {
	      g_print ("cube\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (rotate_checkbutton)))
	    {
	      g_print ("rotate\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (zoom_checkbutton)))
	    {
	      g_print ("zoom\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (move_checkbutton)))
	    {
	      g_print ("move\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (resize_checkbutton)))
	    {
	      g_print ("resize\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (placement_checkbutton)))
	    {
	      g_print ("placement\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (menu_checkbutton)))
	    {
	      g_print ("menu\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (switcher_checkbutton)))
	    {
	      g_print ("switcher\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (scale_checkbutton)))
	    {
	      g_print ("scale\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (decoration_checkbutton)))
	    {
	      g_print ("decoration\n");
	    }
	  else
	    {
	      g_print ("\n");
	    }

	}
      else
	{
	  g_print ("software rendering\n");

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) ==
	      0)
	    {
	      g_print ("default settings\n");
	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (dropshadow_checkbutton)))
		{
		  g_print ("-c\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (avoid_checkbutton)))
		{
		  g_print ("-C\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadeinout_checkbutton)))
		{
		  g_print ("-f\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadewindow_checkbutton)))
		{
		  g_print ("-F\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      gdouble blur =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (blur_spinbutton));
	      printf ("%f\n", blur);
	      gdouble translucency =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (translucency_spinbutton));
	      printf ("%f\n", translucency);
	      gdouble left =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (left_spinbutton));
	      printf ("%f\n", left);
	      gdouble top =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (top_spinbutton));
	      printf ("%f\n", top);
	      gdouble fadeinopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeinopacity_spinbutton));
	      printf ("%f\n", fadeinopacity);
	      gdouble fadeoutopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeoutopacity_spinbutton));
	      printf ("%f\n", fadeoutopacity);
	      gdouble deltatime =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (time_spinbutton));
	      printf ("%f\n", deltatime);
	    }

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) ==
	      1)
	    {
	      g_print ("optimal settings\n");
	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (dropshadow_checkbutton)))
		{
		  g_print ("-c\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (avoid_checkbutton)))
		{
		  g_print ("-C\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadeinout_checkbutton)))
		{
		  g_print ("-f\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadewindow_checkbutton)))
		{
		  g_print ("-F\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      gdouble blur =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (blur_spinbutton));
	      printf ("%f\n", blur);
	      gdouble translucency =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (translucency_spinbutton));
	      printf ("%f\n", translucency);
	      gdouble left =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (left_spinbutton));
	      printf ("%f\n", left);
	      gdouble top =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (top_spinbutton));
	      printf ("%f\n", top);
	      gdouble fadeinopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeinopacity_spinbutton));
	      printf ("%f\n", fadeinopacity);
	      gdouble fadeoutopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeoutopacity_spinbutton));
	      printf ("%f\n", fadeoutopacity);
	      gdouble deltatime =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (time_spinbutton));
	      printf ("%f\n", deltatime);
	    }

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (software_combobox)) ==
	      2)
	    {
	      g_print ("custom settings\n");

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (dropshadow_checkbutton)))
		{
		  g_print ("-c\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (avoid_checkbutton)))
		{
		  g_print ("-C\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadeinout_checkbutton)))
		{
		  g_print ("-f\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      if (gtk_toggle_button_get_active
		  (GTK_TOGGLE_BUTTON (fadewindow_checkbutton)))
		{
		  g_print ("-F\n");
		}
	      else
		{
		  g_print ("\n");
		}

	      gdouble blur =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (blur_spinbutton));
	      printf ("%f\n", blur);
	      gdouble translucency =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (translucency_spinbutton));
	      printf ("%f\n", translucency);
	      gdouble left =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (left_spinbutton));
	      printf ("%f\n", left);
	      gdouble top =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (top_spinbutton));
	      printf ("%f\n", top);
	      gdouble fadeinopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeinopacity_spinbutton));
	      printf ("%f\n", fadeinopacity);
	      gdouble fadeoutopacity =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON
					   (fadeoutopacity_spinbutton));
	      printf ("%f\n", fadeoutopacity);
	      gdouble deltatime =
		gtk_spin_button_get_value (GTK_SPIN_BUTTON (time_spinbutton));
	      printf ("%f\n", deltatime);

	    }
	}

    }
  else
    {
      int t;
      g_print ("disable effects\n");
      for (t = 1; t < 15; t++)
	g_print ("\n");
    }

  gtk_main_quit ();
}

void
on_dropshadow_checkbutton_toggled (GtkButton * button, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_avoid_checkbutton_toggled (GtkButton * button, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_fadeinout_checkbutton_toggled (GtkButton * button, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_fadewindow_checkbutton_toggled (GtkButton * button, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_blur_spinbutton_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_translucency_spinbutton_changed (GtkSpinButton * spinbutton,
				    gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_left_spinbutton_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_top_spinbutton_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_fadeinopacity_spinbutton_changed (GtkSpinButton * spinbutton,
				     gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_fadeoutopacity_spinbutton_changed (GtkSpinButton * spinbutton,
				      gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}


void
on_time_spinbutton_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
}

void
on_license_button_clicked (GtkButton * button, gpointer user_data)
{
  notebook = lookup_widget (GTK_WIDGET (window), "notebook");
  gtk_notebook_set_current_page (GTK_NOTEBOOK (notebook), 2);
}


void
on_page1_back_button_clicked (GtkButton * button, gpointer user_data)
{
  notebook = lookup_widget (GTK_WIDGET (window), "notebook");
  gtk_notebook_set_current_page (GTK_NOTEBOOK (notebook), 0);
}


void
on_page2_ok_button_clicked (GtkButton * button, gpointer user_data)
{
  notebook = lookup_widget (GTK_WIDGET (window), "notebook");
  gtk_notebook_set_current_page (GTK_NOTEBOOK (notebook), 0);
}
