/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

extern GtkWidget *window;
extern GtkWidget *notebook;
extern GtkWidget *enable_effects_checkbutton;
extern GtkWidget *hardware_rendering_radiobutton;
extern GtkWidget *software_rendering_radiobutton;
extern GtkWidget *hardware_combobox;
extern GtkWidget *software_combobox;

int
main (int argc, char *argv[])
{

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  if (argv[1] == 0)
    {
      g_print ("This program cannot be run by itself\n");
      g_print ("Please run 'gnome-bling-manager' instead\n");
      gtk_main_quit ();
      return 1;
    }

  else
    {
      window = create_window ();
      gtk_widget_show (window);

      if (!strcmp (argv[1], "enabled"))
	{
	  gtk_toggle_button_set_active (enable_effects_checkbutton, TRUE);
	}

      if (!strcmp (argv[1], "disabled"))
	{
	  gtk_toggle_button_set_active (enable_effects_checkbutton, FALSE);
	}

      if (!strcmp (argv[2], "hardware"))
	{
	  gtk_toggle_button_set_active (hardware_rendering_radiobutton, TRUE);
	}
      if (!strcmp (argv[2], "software"))
	{
	  gtk_toggle_button_set_active (software_rendering_radiobutton, TRUE);
	}
      if (!strcmp (argv[3], "hwati"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (hardware_combobox), 0);
	}
      if (!strcmp (argv[3], "hwnv"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (hardware_combobox), 1);
	}
      if (!strcmp (argv[3], "hwnull"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (hardware_combobox), 2);
	}

      if (!strcmp (argv[3], "swdefault"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 0);
	}
      if (!strcmp (argv[3], "swoptimal"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 1);
	}
      if (!strcmp (argv[3], "swcustom"))
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (software_combobox), 2);
	}

      gtk_main ();
      return 0;
    }

}
